// ==========  This file is under  LGPL, the GNU Lesser General Public Licence
// ==========  Dialing Lemmatizer (www.aot.ru)
// ==========  Copyright by Alexey Sokirko, Andrey Putrin
// ==========  Changed by Pavel Makarov (January 2007), e-mail: PavMakarov@gmail.com

#ifndef __LEMMATIZERS_H_
#define __LEMMATIZERS_H_

#include "MorphDict.h"

#ifdef DLLInterface
#undef DLLInterface
#endif	// DLLInterface

#ifdef _NO_AOTLEMMDLL	//    /Project/Settings/C++/Preprocessor/Preprocessor definitions/
						//     -DLL  AOTLemm
#define DLLInterface

#else					// DLL  AOTLemm

#ifdef _DLLExportAOTLemm//    /Project/Settings/C++/Preprocessor/Preprocessor definitions/   DLL
#define DLLInterface	__declspec( dllexport )
#else
#define DLLInterface	__declspec( dllimport )
#endif	// _DLLExportAOTLemm

#endif	// _NO_AOTLEMMDLL

//   
class CLemmatizer  : public CMorphDict
{
protected:
	set<string>		m_PrefixesSet;	//   

	void			ReadOptions(wstring wsFileName);	//     morph.options

public:
	bool			m_bLoaded;
	bool			m_bAllowRussianJo;
	
	CLemmatizer(MorphLanguageEnum Language);
	virtual			~CLemmatizer();

	virtual void	FilterSrc(string& src) const = 0;	//    

//  
	//   
	MorphLanguageEnum GetLanguage()  const {return m_pFormAutomat->m_Language; }
	
	//      
	bool			LoadDictionariesRegistry(wstring& wsDictPath, string& strError); 

	//       
	bool			LemmatizeWord(string& InputWordStr, vector<CAutomAnnotationInner>& results) const;
};

/////////////////////////////////////////////////////////////////////////////
class CLemmatizerRussian : public CLemmatizer
{
public:
	CLemmatizerRussian();
	virtual ~CLemmatizerRussian() {}
	void FilterSrc(string& src) const;
};

class  CLemmatizerEnglish : public CLemmatizer
{
	void FilterSrc(string& src) const;
public:
	CLemmatizerEnglish();
	virtual ~CLemmatizerEnglish() {}
	
};

class  CLemmatizerGerman: public CLemmatizer
{
	void FilterSrc(string& src) const;
public:
	CLemmatizerGerman();
	virtual ~CLemmatizerGerman() {};
	
};

/////////////////////////////////////////////////////////////////////////////
//   -   

//     
DLLInterface	bool	LoadLemmatizer(wchar_t* wcDictPath, int nLang, double* pdLoadTime = NULL);

// ,   
DLLInterface	bool	IsLemmatizerLoad(int nLang);

//     
DLLInterface	void	UnloadLemmatizer(int nLang);

//    
DLLInterface	bool	GetLemmas(char* cInputWord, int nLang, char* cLemmas, int nMaxBufferSize, char cLemmasSeparator);

#endif //__LEMMATIZERS_H_

