// ==========  This file is under  LGPL, the GNU Lesser General Public Licence
// ==========  Dialing Syntax Analysis (www.aot.ru)
// ==========  Copyright by Alexey Sokirko
// ==========  Changed by Pavel Makarov (January 2007), e-mail: PavMakarov@gmail.com

#ifndef utilit_classes_h
#define utilit_classes_h

#include "utilit.h"

//     ,     char
class CShortString
{
	vector<char>::const_iterator m_pStringPointer;
public:
	CShortString(vector<char>::const_iterator pData);

	BYTE GetLength() const;
	vector<char>::const_iterator GetData() const;
	const char*	GetString() const;
};

//     CShortString
class IsLessShortString : public std::binary_function<const CShortString&, const char*, bool>
{
public:
	bool operator()(const CShortString& Item1,	const char* Item2) const;
	bool operator()(const char* Item1,			const CShortString& Item2) const;
	bool operator()(const CShortString& Item1,	const CShortString& Item2) const;
};

// ,       CShortString
class CShortStringHolder : public vector<CShortString> 
{
	vector<char> m_Buffer;
	template<class T>
		bool CreateFromSequence(T begin, T end);
public:	
	//     
	void	ReadShortStringHolder(wstring wsFileName);
};

//         
class StringTokenizer
{
private:
	char *text_ptr;
	char *text;
	int i;
	string delims;
	char *_val;

	bool is_delim(char ch) const;
	void initialize(const char *_text, const char *_delims);

public:
	//-------------------------------------------------------
	StringTokenizer(const char *_text, const char *_delims);
	~StringTokenizer();
	const char * operator ()();
	string next_token ();

	const char * get_rest () const;
	const char *val() const;
	int  count() const;
	bool has_next() const;
	void reinitialize(const char *_text, const char *_delims);
};

#endif	// utilit_classes_h

